{
  open Parser        (* The type token is defined in parser.mli *)
}

rule token = parse
  [' ' '\t' '\n']     { token lexbuf }     (* skip blanks *)
| '['            { LSQUARE }
| ']'            { RSQUARE }
| '('            { LPAREN }
| ')'            { RPAREN }
| ':'            { COLON }
| "<:"           { STYPE }
| '.'            { DOT }
| "Top"          { TOP }
| "->"           { ARROW }
| "All"          { FORALL }
| "lambda"       { LAMBDA }
| '='            { EQUALS }
| '{'            { LCURLY }
| '}'            { RCURLY }
| ','            { COMMA }
| ';'            { SEMICOLON }
| "let"          { LET }
| "in"           { IN }
| "test"         { TEST }
| "|-"           { TURNSTILE }
| "--->"         { STEP }
| '?'            { QUESTION }
| '*'            { STAR }
| '"'            { QUOTE}
| ['A'-'Z'] ['A'-'Z' 'a'-'z' '0'-'9' '_']* as x  { UCID x }
| ['a'-'z' '0'-'9'] ['A'-'Z' 'a'-'z' '0'-'9' '_']* as x  { LCID x }
| eof            { EOF }
